import urllib2
import simplejson as json
#import pickle
import socket
from time import time

host=socket.gethostname()
port=6785
site='http://'+host
site+=':'+str(port)
print 'testing on site : '+site
print '=====testing serviceMap====='
url = '/'.join([site,'serviceMap'])
try:
  start=time()
  print 'start timing ',start
  response=urllib2.urlopen(urllib2.Request(url))
  json.loads(response.read())
  print 'end timing ',time()
  elapse=time()-start
  print 'serviceMap takes time ',elapse
except IOError,e:
  if hasattr(e,'code'):
    print 'The server couldn\'t fulfill the request'
    print 'Error code: ',e.code
  elif hasattr(e,'reason'):
    print 'failed to reach a server '
    print 'Reason: ',e.reason
  else:
    print "know not"


print '=====testing getAllTags====='
url = '/'.join([site,'iov','getTags'])
url += '?det=LUMINOSITY&service=cms_orcoff_prod&schema=CMS_COND_31X_RUN_INFO'
print 'query: ',url
taglist=[]
try:
  start=time()
  print 'start timing ',start
  response=urllib2.urlopen(urllib2.Request(url))
  result=json.loads(response.read())
  print 'end timing ',time()
  elapse=time()-start
  print 'getTags from oracle takes time',elapse
  taglist=result.split(' ')
except IOError,e:
  if hasattr(e,'code'):
    print 'The server couldn\'t fulfill the request'
    print 'Error code: ',e.code
  elif hasattr(e,'reason'):
    print 'failed to reach a server '
    print 'Reason: ',e.reason
  else:
    print "know not"
    
print '=====testing getAllTags from frontier====='
url = '/'.join([site,'iov','getTags'])
url += '?det=LUMINOSITY&service=cms_orcoff_prod&schema=CMS_COND_31X_RUN_INFO&viacache=1'
print 'query: ',url
taglist=[]
try:
  start=time()
  print 'start timing ',start
  response=urllib2.urlopen(urllib2.Request(url))
  result=json.loads(response.read())
  taglist=result.split(' ')
  print 'end timing ',time()
  elapse=time()-start
  print 'getAllTags from frontier takes time',elapse
except IOError,e:
  if hasattr(e,'code'):
    print 'The server couldn\'t fulfill the request'
    print 'Error code: ',e.code
  elif hasattr(e,'reason'):
    print 'failed to reach a server '
    print 'Reason: ',e.reason
  else:
    print "know not"

print '=====testing getIOVForTag for 1st tag found ===== ',taglist[0]
url = '/'.join([site,'iov','getIOVForTag'])
url += '?det=Luminosity&service=cms_orcoff_prod&schema=CMS_COND_31X_RUN_INFO&tag='+taglist[0]
print 'query: ',url
try:
  start=time()
  print 'start timing ',start
  response=urllib2.urlopen(urllib2.Request(url))
  result=json.loads(response.read())
  print 'end timing ',time()
  elapse=time()-start
  print 'getIOVForTag takes time',elapse
except IOError,e:
  if hasattr(e,'code'):
    print 'The server couldn\'t fulfill the request'
    print 'Error code: ',e.code
  elif hasattr(e,'reason'):
    print 'failed to reach a server '
    print 'Reason: ',e.reason
  else:
    print "know not"

print '=====testing getPayloadSummariesForTag for 2nd tag found ===== ',taglist[1]
url = '/'.join([site,'iov','getPayloadSummariesForTag'])
url += '?det=Luminosity&service=cms_orcoff_prod&schema=CMS_COND_31X_RUN_INFO&tag='+taglist[1]
print 'query: ',url
try:
  start=time()
  print 'start timing ',start
  response=urllib2.urlopen(urllib2.Request(url))
  result=json.loads(response.read())
  if result['status']!='OK':
     print 'Application Error: ', result['status']
  #else:
     #print 'returned data: ',result['data']
  print 'end timing ',time()
  elapse=time()-start
  print 'getPayloadSummariesForTag takes time ',elapse
except IOError,e:
  if hasattr(e,'code'):
    print 'The server couldn\'t fulfill the request'
    print 'Error code: ',e.code
  elif hasattr(e,'reason'):
    print 'failed to reach a server '
    print 'Reason: ',e.reason
  else:
    print "know not"
    
from CondCore.Utilities import timeUnitHelper
print '=====testing getTrendForTag for 2nd tag found ===== ','lumicraft09_v1'
url = '/'.join([site,'iov','getTrendForTag'])
url += '?det=Luminosity&service=cms_orcoff_prod&schema=CMS_COND_31X_RUN_INFO&tag='+'lumicraft09_v1'
print 'query: ',url
try:
  start=time()
  print 'start timing ',start
  response=urllib2.urlopen(urllib2.Request(url))
  result=json.loads(response.read())
  if type(result)==type('str'):
     print 'Application Error: ', result
  else:
     lumidata=[]
     for block in result:
       sinceLumiTuple=timeUnitHelper.unpackLumiid(block[0])
       tillLumiTuple=timeUnitHelper.unpackLumiid(block[1])
       lumiavg=block[2][0]
       lumidata.append((sinceLumiTuple,tillLumiTuple,lumiavg))
  print 'end timing ',time()
  elapse=time()-start
  print 'getTrendForTag takes time ',elapse
except IOError,e:
  if hasattr(e,'code'):
    print 'The server couldn\'t fulfill the request'
    print 'Error code: ',e.code
  elif hasattr(e,'reason'):
    print 'failed to reach a server '
    print 'Reason: ',e.reason
  else:
    print "know not"

print '=====testing luminosityApp ===== '
url = '/'.join([site,'lumi','allLumiTags'])
url += ''
print 'query: ',url
try:
  start=time()
  print 'start timing ',start
  response=urllib2.urlopen(urllib2.Request(url))
  result=json.loads(response.read())
  #print result
  print 'end timing ',time()
  elapse=time()-start
  print 'allLumiTags takes time ',elapse
except IOError,e:
  if hasattr(e,'code'):
    print 'The server couldn\'t fulfill the request'
    print 'Error code: ',e.code
  elif hasattr(e,'reason'):
    print 'failed to reach a server '
    print 'Reason: ',e.reason
  else:
    print "know not"

print '=====testing luminosityTrend ===== '
url = '/'.join([site,'lumi','LumiSummaries'])
url += '?account=oracle://cms_orcoff_prod/CMS_COND_31X_RUN_INFO&tag='
#url +='lumi83037_v1_iovFrom1'
url += 'lumicraft09_v1'
print 'query: ',url
try:
  start=time()
  print 'start timing ',start
  response=urllib2.urlopen(urllib2.Request(url))
  result=json.loads(response.read())
  print 'end timing ',time()
  elapse=time()-start
  print 'LumiSummaries takes time ',elapse
  print result
except IOError,e:
  if hasattr(e,'code'):
    print 'The server couldn\'t fulfill the request'
    print 'Error code: ',e.code
  elif hasattr(e,'reason'):
    print 'failed to reach a server '
    print 'Reason: ',e.reason
  else:
    print "know not"

